% \iffalse meta-comment
%
% Copyright (c) 2023 by Xin Russell Liu <ginshio78@gmail.com>
%
% This file may be distributed and/or modified under the
% conditions of the LaTeX Project Public License, either
% version 1.3c of this license or (at your option) any later
% version. The latest version of this license is in:
%
% http://www.latex-project.org/lppl.txt
%
% and version 1.3c or later is part of all distributions of
% LaTeX version 2008 or later.
%
%<*internal>
\iffalse
%</internal>
%
%<*readme>
# Nautilus Slide Template
%</readme>
%
%<*internal>
\fi
\def\nameofplainTeX{plain}
\ifx\fmtname\nameofplainTeX\else\expandafter\begingroup\fi
%</internal>
%
%<*internal>
\iffalse
%</internal>
%
%<*license>
Copyright (c) 2023 by Xin Russell Liu <ginshio78@gmail.com>

This file may be distributed and/or modified under the
conditions of the LaTeX Project Public License, either
version 1.3c of this license or (at your option) any later
version. The latest version of this license is in:

http://www.latex-project.org/lppl.txt

and version 1.3c or later is part of all distributions of
LaTeX version 2008 or later.
%</license>
%
%<*internal>
\fi
\def\nameofplainTeX{plain}
\ifx\fmtname\nameofplainTeX\else\expandafter\begingroup\fi
%</internal>
%
%<*driver>
\PassOptionsToPackage{dvipsnames,svgnames,x11names}{xcolor}
\documentclass{ltxdoc}
\usepackage{dtx-style}

\EnableCrossrefs
\CodelineIndex
\RecordChanges

\begin{document}
\DocInput{\jobname.dtx}
\end{document}
%</driver>
%
% \fi
%
% \CheckSum{0}
%
% \CharacterTable
% {Upper-case \A\B\C\D\E\F\G\H\I\J\K\L\M\N\O\P\Q\R\S\T\U\V\W\X\Y\Z
% Lower-case \a\b\c\d\e\f\g\h\i\j\k\l\m\n\o\p\q\r\s\t\u\v\w\x\y\z
% Digits \0\1\2\3\4\5\6\7\8\9
% Exclamation \! Double quote \" Hash (number) \#
% Dollar \$ Percent \% Ampersand \&
% Acute accent \' Left paren \( Right paren \)
% Asterisk \* Plus \+ Comma \,
% Minus \- Point \. Solidus \/
% Colon \: Semicolon \; Less than \<
% Equals \= Greater than \> Question mark \?
% Commercial at \@ Left bracket \[ Backslash \\
%   Right bracket \] Circumflex \^ Underscore \_
% Grave accent \` Left brace \{ Vertical bar \|
% Right brace \} Tilde \~}
%
% \GetFileInfo{\jobname.dtx}
%
% \def\indexname{Index}
% \IndexPrologue{\section{\indexname}}
%
% \title{\bfseries\color{Indigo}Nautilus Slide Template}
% \author{{Xin Russell Liu}\\\texttt{ginshio78@gmail.com}}
% \date{\fileversion\ (\filedate)}
% \maketitle\thispagestyle{empty}
%
% \clearpage
% \pagestyle{plain}
% \tableofcontents
%
% \clearpage
% \pagestyle{fancy}
% \pagenumbering{arabic}
%
% \section{Introduction}
% \label{sec:introduction}
%
% Nautilus is slide template for beamer by Xin Russell Liu.
%
% This document will try to introduce the use of the template as completely as
% possible. If there is anything unclear, or if you want to make suggestions for
% improvement, you can participate in
% \href{https://github.com/GinShio/beamer-template/issues/}{GitHub Issues}
% Discuss or ask questions.
%
% Welcome contributions, including but not limited to, submitting bugs,
% answering questions, submitting code, etc.
%
% \subsection{Get Code}
% \label{sec:installation}
%
% \begin{description}
% \item[GitHub] realease archive file
%           in \url{https://github.com/GinShio/beamer-template}
% \end{description}
%
% Template is supported for compilation under the \TeX{} Live, but not tested
% with other suites.
%
% \subsection{Component}
%
% \subsection{Usage}
% \label{sec:usage}
%
% Source file of template (\nolinkurl{nautilus.dtx}) is literate programming file,
% to generate documentation, it contains extensive comments.
%
% You can generate a sty file for programming with the following command:
%
% \begin{shell}
%   latex nautilus.ins
% \end{shell}
%
%  Get two new file:
%  \begin{itemize}
%    \item{\nolinkurl{nautilus.sty}: template style file}
%    \item{\nolinkurl{dtx-style.sty}: documentation style file}
%  \end{itemize}
%
%  \subsubsection{GNU Make}
%  \label{sec:use-gnu-make}
%
%  TODO
%
%  \subsubsection{latexmk}
%  \label{sec:use-latexmk}
%
%  Latexmk can automatically generate documents written in latex, supports
%  different tool chains, and tools that require multiple compilations.
%
% \begin{shell}
%   latexmk example.tex    # generate example
%   latexmk nautilus.dtx   # generate this documentation
%   latexmk -c             # clean intermediate files
% \end{shell}
%
% If you want to configure the \texttt{latexmk}, modify
% the \nolinkurl{latexmkrc}.
%
% \subsection{Upgrade}
% \label{sec:upgrade}
%
% Download the latest files, and copy \nolinkurl{nautilus.ins} and
% \nolinkurl{nautilus.dtx} to your working directory.
%
% Then regenerate ins file according to \autoref{sec:usage}.
%
% \section{Setup}
% \label{sec:setup}
%
% \subsection{Options}
% \label{sec:setup-options}
%
% \DescribeOption{theme}
%
% Available themes are: \textsf{AMD}, \textsf{thu}.
%
% \begin{latex}
%   % use AMD theme
%   \usetheme[theme=AMD]{nautilus}
% \end{latex}
%
% \subsection{Configuration}
% \label{sec:setup-configuration}
%
% The template uses the key-value form for parameter configuration.
%
% \DescribeMacro{\nautilussetup}
% \begin{latex}
%   \nautilussetup{
%     key1 = value1,
%     key2 = {a value, with comma},
%   }
%   % multiple invoke
%   \nautilussetup{
%     key3 = value3,
%     key1 = value11, % overwrite the old value
%   }
% \end{latex}
%
% \subsubsection{Endpage info}
% \label{sec:setup-endpage-info}
%
% \DescribeOption{endmessage}
% Default end message is \texttt{Thank you for watching}. If
% {\color{nautilus@option} endmessage} is empty, only show \texttt{End.} in end
% page.
%
% \begin{latex}
%   \nautilussetup{
%     endmessage = {}, % show End.
%   }
% \end{latex}
%
% \subsection{Generate Page}
% \label{sec:setup-gen-page}
%
% \DescribeMacro{\nautilustitle}
% \DescribeMacro{\nautilusqna}
% \DescribeMacro{\nautilusend}
%
% \begin{latex}
% \nautilustitle % make title page
% \nautilusqna   % make q&a page
% \nautilusend   % make end page
% \end{latex}
%
% \clearpage
%
% \section{Implementation}
% \label{sec:implementation}
%
% \subsection{Basic info}
% \label{sec:impl-basic-info}
% Version, copy from \href{https://gitlab.fi.muni.cz/external_relations/document_templates/fibeamer}{fibeamer}.
%    \begin{macrocode}
{\def\nautilus@versiondef#1#2#3{
    \gdef\nautilus@version@number{#1}
    \gdef\nautilus@version@date{#2}
    \gdef\nautilus@version{#2 #1 Nautilus slide template}
    \gdef\nautilus@latexe@version{#3}}
  \nautilus@versiondef{v0.1.0}{2023/04/01}{2017/04/15}}
\NeedsTeXFormat{LaTeX2e}[\nautilus@latexe@version]
%<theme> \ProvidesPackage{beamerthemenautilus}[\nautilus@version]
%<inner> \ProvidesPackage{beamerinnerthemenautilus}[\nautilus@version]
%<outer> \ProvidesPackage{beamerouterthemenautilus}[\nautilus@version]
%<dtx-style> \ProvidesFile{nautilus.dtx}[\nautilus@version]
%    \end{macrocode}
%
% Error handling, copy from \href{https://github.com/tuna/thuthesis}{thuthesis}.
%    \begin{macrocode}
%<*master>
\newcommand\nautilus@info[1]{%
  \ClassInfo{nautilus}{#1}{}%
}
\newcommand\nautilus@warning[1]{%
  \ClassWarning{nautilus}{#1}%
}
\newcommand\nautilus@error[1]{%
  \ClassError{nautilus}{#1}{}%
}
\newcommand\nautilus@patch@error[1]{%
  \nautilus@error{Failed to patch command \protect#1}%
}
\newcommand\nautilus@deprecate[2]{%
  \def\nautilus@@tmp{#2}%
  \nautilus@warning{%
    The #1 is deprecated%
    \ifx\nautilus@@tmp\@empty\else
      . Use #2 instead%
    \fi
  }%
}
%</master>
%    \end{macrocode}
%
% Check \LaTeXe{} kernel version.
%    \begin{macrocode}
\@ifl@t@r\fmtversion{\nautilus@latexe@version}{}{
  \nautilus@error{%
    TeX Live 2017 or later version is required to compile this document%
  }
}
%    \end{macrocode}
%
% Must use Xe\LaTeX{} or Lua\LaTeX{}.
%    \begin{macrocode}
\RequirePackage{iftex}
\ifXeTeX\else
  \ifLuaTeX\else
    \nautilus@error{XeLaTeX or LuaLaTeX is required to compile this document}
  \fi
\fi
%    \end{macrocode}
%
% Implement string case.
%
%    \begin{macrocode}
%<*master>
\RequirePackage{pdftexcmds}
\newcommand{\stringcases}[3]{%
  \romannumeral\str@case{#1}#2{#1}{#3}\q@stop
}
\newcommand{\str@case}[3]{%
  \ifnum\pdf@strcmp{\expanded{#1}}{\unexpanded{#2}}=\z@
    \expandafter\@firstoftwo
  \else
    \expandafter\@secondoftwo
  \fi
    {\str@case@end{#3}}
    {\str@case{#1}}%
}
\newcommand{\str@case@end}{}
\long\def\str@case@end#1#2\q@stop{\z@#1}
%</master>
%    \end{macrocode}
%
% Check documentation class, must be beamer.
%
%    \begin{macrocode}
%<nautilus> \@ifclassloaded{beamer}{}{%
%<nautilus>   \nautilus@error{Documentation class must be beamer}
%<nautilus> }
%    \end{macrocode}
%
% The theme uses the following packages:
% \begin{itemize}
%     \item{\textsf{ifthen} --
%           This package is used to construct compound conditionals.}
%     \item{\textsf{ifpdf} --
%           This package is used to check, whether the document is being typeset
%           in DVI mode. If it is, then the |\pdfpagewidth| and |\pdfpageheight|
%           dimensions are defined, so that positioning in TikZ works
%           correctly.}
%     \item{\textsf{textpos}}
%     \item{\textsf{tikz} --
%           This package is used to position the logo and the frame number on a
%           frame.}
%     \item{\textsf{kvdefinekeys} --
%           This package is used to define the setup keys.
%           }
%     \item{\textsf{kvsetkeys} --
%           This package is used to define the setup keys.
%           }
%     \item{\textsf{kvoptions} --
%           This package is used to define the setup keys.
%           }
%     \item{\textsf{pgfcore} --
%           This package is used to draw the dashed line at the title frame.}
%     \item{\textsf{xcolor} --
%           This package is used to setup color.}
%     \item{\textsf{xfp} --
%           This package is used to calculate logo position.}
%   \end{itemize}
%
%    \begin{macrocode}
\RequirePackage{xcolor}
%<nautilus> \RequirePackage{ifthen}
%<nautilus> \RequirePackage{ifpdf}
%<nautilus> \RequirePackage[absolute,overlay]{textpos}
%<nautilus> \RequirePackage{tikz}
%<nautilus> \RequirePackage{kvdefinekeys}
%<nautilus> \RequirePackage{kvsetkeys}
%<nautilus> \RequirePackage{kvoptions}
%<nautilus> \RequirePackage{pgfcore}
%<nautilus> \RequirePackage{xfp}
%<nautilus> \ifpdf\else%
%<nautilus>   \@ifundefined{pdfpagewidth}{\newdimen\pdfpagewidth}{}%
%<nautilus>   \@ifundefined{pdfpageheight}{\newdimen\pdfpageheight}{}%
%<nautilus>   \pdfpagewidth=\paperwidth%
%<nautilus>   \pdfpageheight=\paperheight%
%<nautilus> \fi
%    \end{macrocode}
%
% \subsection{Master}
% \label{sec:impl-master}
%
% \subsubsection{Begin master code}
% \label{sec:impl-masetr-begin}
%
%    \begin{macrocode}
%<*theme>
\mode<presentation>
%    \end{macrocode}
%
% \subsubsection{Master variable}
% \label{sec:impl-master-variable}
%
% This part of the outer theme defines the geometry of the frames
% along with other dimensions.
%
% Copy from fibeamer.
%
%    \begin{macrocode}
\newlength\nautilus@lengths@baseunit%
\nautilus@lengths@baseunit=3.75mm
% The footer padding
\newlength\nautilus@lengths@footerpad%
\setlength\nautilus@lengths@footerpad{\nautilus@lengths@baseunit}
% The side margins
\newlength\nautilus@lengths@margin%
\setlength\nautilus@lengths@margin{3\nautilus@lengths@baseunit}
\setbeamersize{%
  text margin left=\nautilus@lengths@margin,
  text margin right=\nautilus@lengths@margin,
}
% The upper margin
\newlength\nautilus@lengths@titleline%
\setlength\nautilus@lengths@titleline{3\nautilus@lengths@baseunit}
% The background clipping
\newlength\nautilus@lengths@clipbottom%
\setlength\nautilus@lengths@clipbottom\paperwidth%
\addtolength\nautilus@lengths@clipbottom{-\paperheight}%
\setlength\nautilus@lengths@clipbottom{0.5\nautilus@lengths@clipbottom}
\newlength\nautilus@lengths@cliptop%
\setlength\nautilus@lengths@cliptop\paperwidth%
\addtolength\nautilus@lengths@cliptop{-\nautilus@lengths@clipbottom}
%    \end{macrocode}
%
% Logo size.
%    \begin{macrocode}
\newlength\nautilus@lengths@logowidth%
\setlength\nautilus@lengths@logowidth{6\nautilus@lengths@baseunit}
\newlength\nautilus@lengths@logoheight%
\setlength\nautilus@lengths@logoheight{0.4\nautilus@lengths@logowidth}
%    \end{macrocode}
%
% \subsubsection{Master options}
% \label{sec:impl-master-options}
%
% \DescribeOption{theme}
%    \begin{macrocode}
\def\nautilus@theme{AMD}
\DeclareOptionBeamer{theme}{\def\nautilus@theme{#1}}
\ProcessOptionsBeamer%
%    \end{macrocode}
%
% \subsubsection{Master setup}
% \label{sec:impl-master-setup}
%
% Define Basic configuration.
%
%    \begin{macrocode}
\hyphenation{Nautilus-Beamer}
\SetupKeyvalOptions{
  family=nautilus,
  prefix=nautilus@,
  setkeys=\kvsetkeys,
}
%    \end{macrocode}
%
% \begin{macro}{\nautilussetup}
%
%    \begin{macrocode}
\let\nautilus@setup@hook\@empty
\newcommand\nautilussetup[1]{%
  \let\nautilus@setup@hook\@empty
  \kvsetkeys{nautilus}{#1}%
  \nautilus@setup@hook%
}
%    \end{macrocode}
% \end{macro}
%
% Define \emph{key-value}s, example:
%
% \begin{latex}
%   \nautilus@define@key{
%     <key> = {
%       name = <name>,
%       choices = {
%         <choice1>,
%         <choice2>,
%       },
%       default = <default>,
%     },
%   }
% \end{latex}
%
%    \begin{macrocode}
\newcommand\nautilus@define@key[1]{%
  \kvsetkeys{nautilus@key}{#1}%
}
\kv@set@family@handler{nautilus@key}{%
%    \end{macrocode}
%
% \texttt{nautilussetup} deposits \emph{value} into
% \texttt{nautilus@\emph{key}}, \texttt{nautilus@@default} means the empty value
% is default.
%    \begin{macrocode}
  \@namedef{nautilus@#1@@name}{#1}%
  \def\nautilus@@default{}%
  \def\nautilus@@choices{}%
  \kv@define@key{nautilus@value}{name}{%
    \@namedef{nautilus@#1@@name}{##1}%
  }%
  \@namedef{nautilus@#1@@check}{}%
  \@namedef{nautilus@#1@@code}{}%
  \kv@define@key{nautilus@value}{choices}{%
    \def\nautilus@@choices{##1}%
    \@namedef{nautilus@#1@@reset}{}%
%    \end{macrocode}
% \texttt{nautilus@\emph{key}@check} check that value is valid, and set
% \texttt{ifnautilus@\emph{name}@\emph{value}}.
%
%    \begin{macrocode}
    \@namedef{nautilus@#1@@check}{%
      \@ifundefined{%
        ifnautilus@\@nameuse{nautilus@#1@@name}@\@nameuse{nautilus@\@nameuse{nautilus@#1@@name}}%
      }{%
        \nautilus@error{Invalid value "#1 = \@nameuse{nautilus@\@nameuse{nautilus@#1@@name}}"}%
      }%
      \@nameuse{nautilus@#1@@reset}%
      \@nameuse{nautilus@\@nameuse{nautilus@#1@@name}@\@nameuse{%
          nautilus@\@nameuse{nautilus@#1@@name}}true}%
    }%
  }%
  \kv@define@key{nautilus@value}{default}{%
    \def\nautilus@@default{##1}%
  }%
  \kvsetkeys{nautilus@value}{#2}%
  \@namedef{nautilus@\@nameuse{nautilus@#1@@name}}{}%
%    \end{macrocode}
%
% the First of \emph{choice} is default value, and define
% \texttt{ifnautilus@\emph{name}@\emph{choice}} for each \emph{choice}.
%
%    \begin{macrocode}
  \kv@set@family@handler{nautilus@choice}{%
    \ifx\nautilus@@default\@empty
      \def\nautilus@@default{##1}%
    \fi
    \expandafter\newif\csname ifnautilus@\@nameuse{nautilus@#1@@name}@##1\endcsname
    \expandafter\g@addto@macro\csname nautilus@#1@@reset\endcsname{%
      \@nameuse{nautilus@\@nameuse{nautilus@#1@@name}@##1false}%
    }%
  }%
  \kvsetkeys@expandafter{nautilus@choice}{\nautilus@@choices}%
%    \end{macrocode}
%
% Assign \emph{default} to \texttt{nautilus@\emph{name}}.
%
%    \begin{macrocode}
  \expandafter\let\csname nautilus@\@nameuse{nautilus@#1@@name}\endcsname\nautilus@@default
  \expandafter\ifx\csname nautilus@\@nameuse{nautilus@#1@@name}\endcsname\@empty\else
    \@nameuse{nautilus@#1@@check}%
  \fi
%    \end{macrocode}
%
% Interface of \texttt{nautilussetup}.
%
%    \begin{macrocode}
  \kv@define@key{nautilus}{#1}{%
    \@namedef{nautilus@\@nameuse{nautilus@#1@@name}}{##1}%
    \@nameuse{nautilus@#1@@check}%
    \@nameuse{nautilus@#1@@code}%
  }%
}
\newcommand\nautilus@option@hook[2]{%
  \expandafter\g@addto@macro\csname nautilus@#1@@code\endcsname{#2}%
}
%    \end{macrocode}
%
% Define options.
%
%    \begin{macrocode}
\nautilus@define@key{
  endmessage = {
    default = {Thank you for watching!},
  },
  qnamessage,
  logo,
  logopath,
}
%    \end{macrocode}
%
% Process author info.
%    \begin{macrocode}
\newcounter{nautilus@author@count}
\newcommand\nautilus@author@process[1]{%
  \ifcase\c@nautilus@author@count  % == 0
    \gdef\nautilus@author@name{#1}%
  \or  % == 1
    \gdef\nautilus@author@email{#1}%
  \fi
  \stepcounter{nautilus@author@count}%
}
\newcommand\nautilus@author@parse[1]{%
  \setcounter{nautilus@author@count}{0}%
  \gdef\nautilus@author@name{}%
  \gdef\nautilus@author@email{}%
  \expandafter\comma@parse\expandafter{#1}{\nautilus@author@process}%
  \nautilus@author@name%
  \ifx\nautilus@author@email\@empty\else
    \scriptsize\space\space<\href{mailto:\nautilus@author@email}{\nautilus@author@email}>
  \fi
}
\def\nautilus@author@default{Name}
%    \end{macrocode}
%
% Process array of reviewers and supervisors.
%
%    \begin{macrocode}
\newcommand\nautilus@multiname@list[2]{\@for\tmp:=#1\do{#2{\tmp}}}
%    \end{macrocode}
%
% \subsubsection{Master theme}
% \label{sec:impl-master-theme}
%
% Use theme.
%    \begin{macrocode}
\usecolortheme{\nautilus@theme}
\usefonttheme{\nautilus@theme}
\useinnertheme{\nautilus@theme}
\useoutertheme{nautilus}
%    \end{macrocode}
%
% \subsubsection{Master frame}
% \label{sec:impl-master-frame}
%
% Define the special frame, e.g. titlepage, endpage.
%
% Basic macro for ending page.
%
%    \begin{macrocode}
\newcommand\nautilus@ending@page[2][nautilus]{
  \pagenumbering{empty}%
  \ifbeamer@inframe%
    \nautilus@error{#1 must be called outside frame.}%
  \else%
    \nautilus@frame{%
      \usebeamerfont{title}%
      \begin{minipage}{\textwidth}%
        \huge\centering\expanded{#2}%
      \end{minipage}%
    }%
}%
%    \end{macrocode}
%
% \subsubsection{Navigation symbols}
% \label{sec:impl-master-navigation}
%
% The outer theme completely culls the bottom navigation.
%    \begin{macrocode}
\defbeamertemplate{navigation symbols}{nautilus}{%
  \usebeamercolor[fg]{navigation symbols}%
  \insertslidenavigationsymbol%
  \insertframenavigationsymbol%
  \insertsubsectionnavigationsymbol%
  \insertsectionnavigationsymbol%
  \insertdocnavigationsymbol%
  % \insertbackfindforwardnavigationsymbol%
}%
\defbeamertemplate{navigation symbols}{nautilus-none}{}
%    \end{macrocode}
%
% \subsubsection{End Master code}
% \label{sec:impl-master-end}
%
%    \begin{macrocode}
\mode<all>
%</theme>
%    \end{macrocode}
%
% \subsection{Outer theme}
% \label{sec:impl-outer}
%
% This is the base inner theme for presentations.
%
% \subsubsection{Begin outter code}
% \label{sec:impl-outer-begin}
%
%    \begin{macrocode}
%<*outer>
\mode<presentation>
%    \end{macrocode}
%
% \subsubsection{Title page}
% \label{sec:impl-outer-title-page}
%
% The folder path to logo.
%    \begin{macrocode}
\ifx\nautilus@logopath\@empty\else%
  \graphicspath{\nautilus@logopath}
\fi%
%    \end{macrocode}
%
%    \begin{macrocode}
\definecolor{DIEGrey}{RGB}{255,255,255}
\definecolor{DIEBlue}{RGB}{0,76,153}
\definecolor{DIEWhite}{RGB}{255,255,255}
\definecolor{UDeAgreen}{RGB}{23,78,66}
%    \end{macrocode}
%
% Set the default background and logo.
%    \begin{macrocode}
\def\nautilus@default@title@background{%
  \begin{pgfpicture}[remember picture, overlay]
    \pgf@relevantforpicturesizefalse
    \pgftransformyshift{-.1133\paperheight}
%    \end{macrocode}
%
% Backgorund color.
%    \begin{macrocode}
    \pgfpathrectanglecorners{\pgfpoint{0}{.42\paperheight}}{\pgfpoint{\paperwidth}{-.5\paperheight}}
    \pgfsetfillcolor{DIEBlue}
    \pgfusepath{fill}
%    \end{macrocode}
%
% White bar across top.
%    \begin{macrocode}
    \pgfpathmoveto{\pgfpointorigin}
    \pgfpathrectanglecorners{\pgfpoint{0}{.4\paperheight}}{\pgfpoint{\paperwidth}{.42\paperheight}}
    \pgfsetfillcolor{white}
    \pgfusepath{fill}
%    \end{macrocode}
%
% Short bar on left.
%    \begin{macrocode}
    \pgfpathrectanglecorners{\pgfpoint{0pt}{.41\paperheight}}{\pgfpoint{.12\paperwidth}{.42\paperheight}}
    \pgfsetfillcolor{DIEBlue}
    \pgfusepath{fill}
%    \end{macrocode}
%
% Logo.
%    \begin{macrocode}
    \ifx\nautilus@logo\@empty\else%
      \pgftext[at=\pgfpoint{.06\paperwidth}{.46\paperheight},center]{%
        \includegraphics[width=.1\paperwidth,height=.06\paperheight,keepaspectratio]{\nautilus@logo}
      }
    \fi%
%    \end{macrocode}
%
% A stroke down the middle.
%    \begin{macrocode}
    \pgfpathmoveto{\pgfpoint{.12\paperwidth}{+.28\paperheight}}
    \pgfpathlineto{\pgfpoint{.12\paperwidth}{-.50\paperheight}}
    \pgfsetlinewidth{.4pt}
    \pgfsetcolor{white}
    \pgfusepath{stroke}
%    \end{macrocode}
%
% End of title background.
%    \begin{macrocode}
  \end{pgfpicture}
}
%    \end{macrocode}
%
% Set the default title and subtitle on the title page.
%    \begin{macrocode}
\def\nautilus@default@title@title{%
  \begin{pgfpicture}[remember picture, overlay]
    \pgf@relevantforpicturesizefalse
    \pgftransformyshift{-.1133\paperheight}
%    \end{macrocode}
%
% set the title on title page.
%    \begin{macrocode}
    \pgftext[at=\pgfpoint{.13\paperwidth}{.1\paperheight},left,base]{%
      \usebeamercolor[fg]{title}
      \Huge\ifx\inserttitle\@empty{Title}\else\inserttitle\fi%
    }
%    \end{macrocode}
%
% set the subtitle on title page.
%    \begin{macrocode}
    \pgftext[at=\pgfpoint{.13\paperwidth}{0},left,base]{%
      \usebeamercolor[fg]{subtitle}
      \Large\ifx\insertsubtitle\@empty\else\insertsubtitle\fi%
    }
%    \end{macrocode}
%
% End of the title and subtitle on the title page.
%    \begin{macrocode}
  \end{pgfpicture}
}
%    \end{macrocode}
%
% Set the default author, insitute and date on the title page.
%    \begin{macrocode}
\def\nautilus@default@title@author{%
  \begin{pgfpicture}[remember picture, overlay]
    \pgf@relevantforpicturesizefalse
    \pgftransformyshift{-.1133\paperheight}
%    \end{macrocode}
%
% set the author on title page.
%    \begin{macrocode}
      \pgftext[at=\pgfpoint{.13\paperwidth}{-.2\paperheight},left,base]{%
        \usebeamercolor[fg]{author}
        \ifx\insertauthor\@empty{Name}\else\insertauthor\fi%
      }
%    \end{macrocode}
%
% set the date on title page.
%    \begin{macrocode}
      \pgftext[at=\pgfpoint{.13\paperwidth}{-.27\paperheight},left,base]{%
        \usebeamercolor[fg]{date}
        \ifx\insertdate\@empty\today\else\insertdate\fi%
      }
%    \end{macrocode}
%
% set the institute on title page.
%    \begin{macrocode}
      \pgftext[at=\pgfpoint{.13\paperwidth}{-.36\paperheight},left,base]{%
        \usebeamercolor[fg]{institute}
        \scriptsize\ifx\insertinstitute\@empty\else\insertinstitute\fi%
      }
%    \end{macrocode}
%
% End of the author, insitute and date on the title page.
%    \begin{macrocode}
  \end{pgfpicture}
}
%    \end{macrocode}
%
% Define title page template.
%    \begin{macrocode}
\defbeamertemplate*{title page}{nautilus}[1][]{%
  \begin{beamercolorbox}[wd=\paperwidth]{titlepage}
    \nautilus@default@title@background%
    \nautilus@default@title@title%
    \nautilus@default@title@author%
  \end{beamercolorbox}
}
%    \end{macrocode}
%
% \begin{macro}{\nautilustitle}
% Generate title page.
%    \begin{macrocode}
\def\nautilustitle{%
  \pagenumbering{Alph}%
  \setcounter{framenumber}{0}
  \ifbeamer@inframe%
    \nautilus@error{\texttt{nautilustitle} must be called outside frame.}
  \else%
    \setbeamertemplate{navigation symbols}[nautilus-none]
    \begin{frame}[plain,noframenumbering]%
      \begin{center}%
        \titlepage%
      \end{center}%
    \end{frame}%
  \fi%
  \setbeamertemplate{navigation symbols}[nautilus]
  \pagenumbering{arabic}%
}%
%    \end{macrocode}
% \end{macro}
%
% \subsubsection{Ending page}
% \label{sec:impl-outer-ending-page}
%
% Define title page command.
%    \begin{macrocode}
\newcommand\nautilus@endingpage{
  \begin{beamercolorbox}[wd=\paperwidth]{titlepage}
    \nautilus@default@title@background%
  \end{beamercolorbox}
}
%    \end{macrocode}
%
% \begin{macro}{\nautilusend}
% Generate ending page.
%    \begin{macrocode}
\def\nautilusend{%
  \ifbeamer@inframe%
    \nautilus@error{\texttt{nautilusend} must be called outside frame.}
  \else%
    \setbeamertemplate{navigation symbols}[nautilus-none]
    \begin{frame}[plain,noframenumbering]%
      \begin{center}%
        \nautilus@endingpage%
      \end{center}%
    \end{frame}%
  \fi%
}%
%    \end{macrocode}
% \end{macro}
%
% \subsubsection{Footer}
% \label{sec:impl-outer-footer}
%
% Begin of footline template.
%    \begin{macrocode}
\defbeamertemplate*{footline}{nautilus}[1][]{%
  \begin{beamercolorbox}[wd=\paperwidth]{footline}
    \ifnum\c@framenumber=0\else%
      \begin{pgfpicture}[overlay]
        \pgf@relevantforpicturesizefalse
        \pgftransformxshift{.072\paperwidth}
        \pgftransformyshift{.015\paperheight}
%    \end{macrocode}
%
% page number.
%    \begin{macrocode}
        \pgftext[right,base]{%
          \usebeamercolor[fg]{framenumber}
          \insertframenumber~/~\inserttotalframenumber%
        }
%    \end{macrocode}
%
% End of template.
%    \begin{macrocode}
      \end{pgfpicture}
    \fi
  \end{beamercolorbox}
}
%    \end{macrocode}
%
% \subsubsection{End outer code}
% \label{sec:impl-outer-end}
%
%    \begin{macrocode}
\mode<all>
%</outer>
%    \end{macrocode}
%
% \subsection{Inner theme}
% \label{sec:impl-inner}
%
% This is the base outer theme for presentations.
%
% \subsubsection{Begin inner code}
% \label{sec:impl-inner-begin}
%
%    \begin{macrocode}
%<*inner>
\mode<presentation>
%    \end{macrocode}

% \subsubsection{End inner code}
% \label{sec:impl-inner-end}
%
%    \begin{macrocode}
\mode<all>
%</inner>
%    \end{macrocode}
%
% \subsection{Dtx style}
% \label{sec:impl-dtx-style}
%
%    \begin{macrocode}
%<*dtx-style>
\ProvidesPackage{dtx-style}

\RequirePackage{fancyhdr}
\RequirePackage[
  top=2.5cm, bottom=2.5cm,
  left=4cm, right=2cm,
  headsep=3mm
]{geometry}
\RequirePackage{hypdoc}
\RequirePackage{listings}
\RequirePackage{etoolbox}

\hypersetup{
  colorlinks=true,
  linkcolor=Blue,
  filecolor=Magenta,
  urlcolor=Cyan,
  pdflang=en,
  pdftitle={Nautilus Template},
  pdfkeywords={beamer; template; documentation},
}

\colorlet{nautilus@macro}{SlateBlue}
\colorlet{nautilus@option}{SteelBlue}

\patchcmd{\PrintMacroName}{\MacroFont}{\MacroFont\bfseries\color{nautilus@macro}}{}{}
\patchcmd{\PrintDescribeMacro}{\MacroFont}{\MacroFont\bfseries\color{nautilus@macro}}{}{}

% DescribeOption copy from thuthesis
\def\DescribeOption{%
  \leavevmode\@bsphack\begingroup\MakePrivateLetters%
  \Describe@Option
}
\def\Describe@Option#1{%
  \endgroup
  \marginpar{\raggedleft\PrintDescribeOption{#1}}%
  \thu@special@index{option}{#1}\@esphack\ignorespaces
}
\def\PrintDescribeOption#1{\strut \MacroFont\bfseries\sffamily\color{nautilus@option} #1\ }
\def\thu@special@index#1#2{\@bsphack
  \begingroup
  \HD@target
  \let\HDorg@encapchar\encapchar
  \edef\encapchar usage{%
      \HDorg@encapchar hdclindex{\the\c@HD@hypercount}{usage}%
    }%
  \index{#2\actualchar{\string\ttfamily\space#2}
    (#1)\encapchar usage}%
  \index{#1:\levelchar#2\actualchar
    {\string\ttfamily\space#2}\encapchar usage}%
  \endgroup
  \@esphack
}

\lstdefinestyle{lstStyleBase}{%
  basicstyle=\small\ttfamily,
  aboveskip=\medskipamount,
  belowskip=\medskipamount,
  lineskip=0pt,
  boxpos=c,
  showlines=false,
  extendedchars=true,
  upquote=true,
  tabsize=2,
  showtabs=false,
  showspaces=false,
  showstringspaces=false,
  numbers=none,
  linewidth=\linewidth,
  xleftmargin=4pt,
  xrightmargin=0pt,
  resetmargins=false,
  breaklines=true,
  breakatwhitespace=false,
  breakindent=0pt,
  breakautoindent=true,
  columns=flexible,
  keepspaces=true,
  gobble=4,
  framesep=3pt,
  rulesep=1pt,
  framerule=1pt,
  backgroundcolor=\color{Gray!5},
  stringstyle=\color{Green!40!Black!100},
  keywordstyle=\bfseries\color{Blue!50!Black},
  commentstyle=\slshape\color{Black!60},
}

\lstdefinestyle{lstStyleShell}{%
  style=lstStyleBase,
  frame=l,
  rulecolor=\color{Purple},
  language=bash,
}
\lstnewenvironment{shell}{\lstset{style=lstStyleShell}}{}

\lstdefinestyle{lstStyleLaTeX}{%
  style=lstStyleBase,
  frame=l,
  rulecolor=\color{Violet},
  language=[LaTeX]TeX,
}
\lstnewenvironment{latex}{\lstset{style=lstStyleLaTeX}}{}

\pagenumbering{roman}
%</dtx-style>
%    \end{macrocode}
%
% \Finale
\endinput
% \iffalse
%   Local Variables:
%   mode: doctex
%   TeX-master: t
%   End:
% \fi
